---
name: Bug report / Problem
about: Create a report to help us improve and help you
title: "[BUG]<Enter comprehensive title>"
labels: bug
assignees: ''

---

**Describe the bug**

<!--A clear and concise description of what the bug is.-->

**To Reproduce**

<!--Steps to reproduce the behavior:-->
1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See error

**Expected behavior**

<!--A clear and concise description of what you expected to happen.-->

**Screenshots**

<!--If applicable, add screenshots to help explain your problem.-->

**ESP3D Firmware:**

- ESP3D FW version: [e.g. 2.1b4] <!-- To get ESP3D informations type `[ESP420]plain` or tell us commit/release you are using -->
- ESP3D-WebUI Version:[e.g. 2.1b14] <!-- Can be found in web page header -->
- Wifi mode:[e.g. STA/AP]
- Flash method: [Arduino Ide / PlatformIO]  
    If you build with Arduino:
    - Arduino ESP8266 package version: [e.g. 2.5.2] <!-- Go to Arduino->tools->boards->board manager->esp8266 -->
- Any change done in FW:

**Target Firmware:**

<!--  tip: to get firmware info type `M115` in console -->
- Name: [e.g. Marlin]
- Version [e.g. 2.0]

**Board used (please complete the following information):**

- MCU:[e.g. ESP32]
- Name:[e.g. NodeMCU2s]
- Flash size: [e.g. 4M: 2M/2M]

**Additional context**

<!--Add any other context about the problem here.
Wiring, decoded stack, etc...-->
